from Products.Archetypes.public import BaseSchema, Schema
from Products.Archetypes.public import BaseContent, registerType

from Products.QuotaAW.config import *

from Products.Archetypes.public import *


from Products.CMFCore import CMFCorePermissions
from AccessControl import ClassSecurityInfo
from Products.CMFCore.utils import getToolByName

from AccessControl import getSecurityManager, SpecialUsers
from Acquisition import aq_base, aq_parent

from Permissions import *
import string


#############################################################################
##                             Setting                                     ##
#############################################################################

schema = BaseSchema +  Schema((
    StringField('title',
                default='Quota',
                widget=StringWidget(label_msgid='label_title',i18n_domain='plone',),
                ),
    IntegerField('max_quota_bytes',
              default='0',
              #write_permission=SetQuota,
              mutator='setMax_quota_bytes',
              widget=IntegerWidget(
                  label="Quota Size in Bytes",
                  description="(0 for no limit)",
                  ),
              ),
    IntegerField('max_quota_objects',
              default='0',
              #write_permission=SetQuota,
              mutator='setMax_quota_objects',
              widget=IntegerWidget(
                  label="Maximum number of Objects",
                  description="(0 for unlimited)",
                  ),
              ),
    IntegerField('max_object_size',
              default='0',
              #write_permission=SetQuota,
              mutator='setMax_object_size',
              widget=IntegerWidget(
                  label="Maximum Object Size in Bytes",
                  description="(0 for unlimited)",
                  ),
              ),
    LinesField('restart_level',
              #write_permission=SetQuota,
              default='0',
              vocabulary='validRestart_level',
              widget=MultiSelectionWidget(label_msgid='label_restart_level',i18n_domain='cmffolder',
                         description="Restart quota counting at these sub levels. Use ',' to separate different " \
                                     " levels. Level 0 is the current level; level 1 is the first sub folder. " \
                                     " e.g. '1,3' will restart quota at the first and third sub-levels; " \
                                     " Set '1' in 'Members' folder will has quota for each member in your portal.",)
        ),
    ))


class QuotaAW(BaseContent):
    """
        Quota AnyWhere
    """
    security = ClassSecurityInfo()
    
    schema = schema
    archetype_name = "QuotaAW"
    
    global_allow = 1
    
    security = ClassSecurityInfo()

    
    content_icon = 'quotaaw_icon.gif'
  
    #security.declareProtected(CMFCorePermissions.View, 'getIcon')
    #def getIcon(self, relative_to_portal=0):
    #    return 'quotaaw_icon.gif'
        

    
    ##### Mutators #####
    security.declareProtected( SetQuota, 'setMax_quota_bytes' ) 
    def setMax_quota_bytes(self, value, **kwargs):
        tool = self.quota_tool
        if not kwargs.has_key('force'):
            if value and (str(value) <> str(tool.MAX_QUOTA_BYTES)):
                if tool.DISABLE_FOLDERISH_SETTING:
                    raise QuotaAWSetQuotaException, \
                              "Folder's setting violate the quota_tool setting. You are not permitted to change the quota setting."
            
        schema = self.Schema()
        field = schema.get('max_quota_bytes', 0)
        field.set(instance=self, value=value)
    
    security.declareProtected( SetQuota, 'setMax_quota_objects')
    def setMax_quota_objects(self, value, **kwargs):
        
        tool = self.quota_tool
        # check if quota_tool disable folderish setting
        if not kwargs.has_key('force'):
            if value and (str(value) <> str(tool.MAX_QUOTA_OBJECTS)):
                if tool.DISABLE_FOLDERISH_SETTING:
                    raise QuotaAWSetQuotaException, \
                              "Folder's setting violate the quota_tool setting. You are not permitted to change the quota setting."
        schema = self.Schema()
        field = schema.get('max_quota_objects', 0)
        field.set(instance=self, value=value)

    security.declareProtected( SetQuota, 'setMax_object_size' )        
    def setMax_object_size(self, value, **kwargs):
        # check if quota_tool disable folderish setting
        tool = self.quota_tool
        if not kwargs.has_key('force'):
            if value and (str(value) <> str(tool.MAX_OBJECT_SIZE)):
                if tool.DISABLE_FOLDERISH_SETTING:
                    raise QuotaAWSetQuotaException, \
                              "Folder's setting violate the quota_tool setting. You are not permitted to change the quota setting."
        schema = self.Schema()
        field = schema.get('max_object_size', 0)
        field.set(instance=self, value=value)
    
    
    security.declareProtected( SetQuota, 'setIs_allow_nested' )        
    def setIs_allow_nested(self, value, **kwargs):
        # check if quota_tool disable folderish setting
        tool = self.quota_tool
        if not kwargs.has_key('force'):
            if value and (str(value) <> str(tool.IS_ALLOW_NESTED)):
                if tool.DISABLE_FOLDERISH_SETTING:
                    raise QuotaAWSetQuotaException, \
                              "Folder's setting violate the quota_tool setting. You are not permitted to change the quota setting."
        
        # check logically possible
        if value not in [1,'1']:
            if self.check_nested():
                 raise QuotaAWNestedException, \
                      "You has nested CMFFolder within this folder, please remove it first before setting the folder to non-nestable."

        schema = self.Schema()
        field = schema.get('is_allow_nested', None)
        field.set(instance=self, value=value)
    
    
    #security.declarePrivate( 'makeDisplayList' )        
    #def makeDisplayList(self, values=None):
    #    if values and type(values) not in [type([]), type(())]:
    #        values = (values,)
    #    if not values: values = []
    #    results = [['', 'Select'],]
    #    for x in values:
    #        results.append([x,x])
    #    values_tuple = tuple(results)
    #    return DisplayList(values_tuple)

    
    security.declarePublic('validRestart_level' )        
    def validRestart_level(self):
        
        phypath = self.aq_parent.getPhysicalPath()
        path = '/'.join(phypath)
        items= self.portal_catalog(path=path)
        #items= self.filterCategory(folder, items)
        #thelist = [0]
        max = 0
        for i in items:
            
            o = i.getObject()
            if o:
                p = o.getPhysicalPath()
                
                #splitpath = p.split('/')
                l = len(p) - len(phypath)
                if max < l:
                    max = l
            
        #thelist = self.makeDisplayList(range(max+1+5))
        #return DisplayList((('', 'Select'), (0, 0), (1, 1), (2, 2), (3, 3), (4, 4)))

        return range(max+1+5)
                
    def manage_afterAdd(self, item, container):
        parent = self.aq_parent
        quotas = parent.contentValues(filter={'portal_type':'QuotaAW',})
        if len(quotas) >1:
            raise QuotaAWObjectException, \
                      "A folder cannot have more than one QuotaAW"
        BaseContent.manage_afterAdd(self, item, container)
        
        
          


registerType(QuotaAW)
